/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * mobilize.c -- persuade people to build military stuff.
 *    Sectors that are mobilized produce Destructive Potential in
 *    proportion to the % they are mobilized.  they are also more
 *    damage-resistant.
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "buffers.h"
#include <signal.h>
#include <ctype.h>
int mobilize_sectdata,mobilize_pdata;

mobilize(Playernum,APcount, argn, args)
int Playernum;
int APcount, argn;
char args[MAXARGS][COMMANDSIZE];
{
int owned=0,x,y,sum_mob=0;
sectortype *s;
planettype *p;

mobilize_pdata = mobilize_sectdata = NEUTRAL_FD;

if (Dir[Playernum-1].level!=LEVEL_PLAN) {
	sprintf(buf,"scope must be a planet.\n");
		notify(Playernum, buf);
	return;
}
if (!enufAP(Playernum,Stars[Dir[Playernum-1].snum]->AP[Playernum-1], APcount)) {
	return;
	}

 openpdata(&mobilize_pdata);
 getplanet(mobilize_pdata,&p,Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
close_file(mobilize_pdata);

 opensectdata(&mobilize_sectdata);
 getsmap(mobilize_sectdata,Smap,p);
 close_file(mobilize_sectdata);

if(argn < 2) {
	sprintf(buf, "Current mobilization: %d    Quota: %d\n", 
			p->info[Playernum-1].comread, p->info[Playernum-1].mob_set);
	notify(Playernum, buf);
		return;
		}



	sum_mob = atoi(args[1]);

	if (sum_mob > 100 || sum_mob < 0) {
		sprintf(buf,"Illegal value.\n");
			notify(Playernum, buf);
		return;
	}


	p->info[Playernum-1].mob_set = sum_mob;
openpdata(&mobilize_pdata);
putplanet(mobilize_pdata,p,Stars[Dir[Playernum-1].snum]->planetpos[Dir[Playernum-1].pnum]);
	 close_file(mobilize_pdata);

	deductAPs(Playernum,APcount, Dir[Playernum-1].snum, 0);

 free(p);

}

