/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 * prof.c -- print out racial profile
 */

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "races.h"
#include "ships.h"
#include "buffers.h"

extern char *Desnames[];
int prof_racedata;
char *Estimate_f(), *Estimate_i();

whois(Playernum, APcount, argn, args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
int i, j, numraces;

if(argn <= 1) {
	notify(Playernum, "You must give a list of player numbers.\n");
	return;
	}
numraces = Numraces();

for(i=1; i<=argn-1; i++) {
	j=atoi(args[i]);
	if(!(j<1 || j>numraces)) {
free(Race);
openracedata(&prof_racedata); 
getrace(prof_racedata, &Race, j);
close_file(prof_racedata);
	sprintf(buf, "[%2d] %s\n", j, Race->name);
	notify(Playernum, buf);
		}
	}

}

profile(Playernum,APcount, argn,args)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
{
 int i, p, numraces;
 racetype *r;

free(Race);
openracedata(&prof_racedata); 
getrace(prof_racedata, &Race,Playernum);
close_file(prof_racedata);

if(argn==1) {
 sprintf(buf,"---==** Racial profile for %s (player %d) **==---\n",Race->name,
		Race->Playernum);
		notify(Playernum, buf); 
if(Race->God) {
	sprintf(buf, "          *** Diety Status ***\n");
	notify(Playernum, buf);
	}

sprintf(buf,"          (default scope /%s/%s)\n\n",Stars[Race->homesystem]->name,
		Stars[Race->homesystem]->pnames[Race->homeplanetnum] );
		notify(Playernum, buf);
 sprintf(buf,"         %10srate: %.1f\n",Race->Thing ? "Infection " : "Birth",Race->birthrate);
 		notify(Playernum, buf); 
sprintf(buf,"             Technology: %.1f\n",Race->tech);
 		notify(Playernum, buf); 
sprintf(buf,"       Avg Intelligence: %u\n",Race->IQ);
 		notify(Playernum, buf); 
sprintf(buf,"                   mass: %.2f\n",Race->mass);
 		notify(Playernum, buf); 
sprintf(buf,"             metabolism: %.1f\n",Race->metabolism);
 		notify(Playernum, buf); 
sprintf(buf,"           adventurists: %.2f%%\n",Race->adventurism*100.0);
 		notify(Playernum, buf); 
sprintf(buf,"       fighting ability: %d\n",Race->fighters);
 		notify(Playernum, buf); 
sprintf(buf,"             # of sexes: %d\n", Race->number_sexes);
		notify(Playernum, buf); 
 if (Race->Thing) {
sprintf(buf,"Mesomorphic race (like \"The Thing\").\n");
		notify(Playernum, buf); 
	}
  sprintf(buf,"planetary conditions preferred by %s:\n", Race->name);
  		notify(Playernum, buf); 
sprintf(buf,"    temperature: %d\n", Temp(Race->conditions[TEMP]) );
  		notify(Playernum, buf); 
sprintf(buf," atmosphere concentrations:\n");
  		notify(Playernum, buf); 
sprintf(buf,"    methane %02d%%    oxygen %02d%%\n",
		Race->conditions[METHANE], Race->conditions[OXYGEN] );
  		notify(Playernum, buf); 
sprintf(buf,"        CO2 %02d%%  hydrogen %02d%%\n", 
		Race->conditions[CO2], Race->conditions[HYDROGEN] );
  		notify(Playernum, buf); 
sprintf(buf,"   nitrogen %02d%%    sulfur %02d%%\n",
		Race->conditions[NITROGEN], Race->conditions[SULFUR] );
  		notify(Playernum, buf); 
sprintf(buf,"     helium %02d%%     other %02d%%\n", 
		Race->conditions[HELIUM], Race->conditions[OTHER]);
  		notify(Playernum, buf); 
sprintf(buf,"Sector type preferences:\n");
  		notify(Playernum, buf); 
sprintf(buf," %c (%11s) %3.2f%%      %c (%11s) %3.2f%%\n", 
	CHAR_SEA, Desnames[DES_SEA], Race->likes[DES_SEA]*100, 
	CHAR_GAS, Desnames[DES_GAS], Race->likes[DES_GAS]*100);
  		notify(Playernum, buf); 
sprintf(buf," %c (%11s) %3.2f%%      %c (%11s) %3.2f%%\n", 
	CHAR_MOUNT, Desnames[DES_MOUNT], Race->likes[DES_MOUNT]*100, 
	CHAR_LAND, Desnames[DES_LAND], Race->likes[DES_LAND]*100);
  		notify(Playernum, buf); 
sprintf(buf," %c (%11s) %3.2f%%      %c (%11s) %3.2f%%\n", 
	CHAR_ICE, Desnames[DES_ICE], Race->likes[DES_ICE]*100, 
	CHAR_PLATED, Desnames[DES_PLATED], Race->likes[DES_PLATED]*100);
		notify(Playernum, buf); 
  if (Race->Gov_ship==0) {
	sprintf(buf,"\nNo designated capitol!!\n");
  		notify(Playernum, buf); 
} else {
	sprintf(buf,"\nDesignated capitol: #%d\n", Race->Gov_ship);
		notify(Playernum, buf); 
	}
  sprintf(buf,"\nTelescope ranges:   ground: %.0f, space: %.0f\n", 
	tele_range(OTYPE_GTELE,Race->tech), tele_range(OTYPE_STELE,Race->tech) );
		notify(Playernum, buf); 
  sprintf(buf,"Gun range: %.0f\n", gun_range(Race, NULL) );
		notify(Playernum, buf); 
} else {

   GetPlayer(args[1], &p, &r);

   if (p== -1) {
	sprintf(buf,"Player does not exist.\n");
		notify(Playernum, buf);
	return;
   }

 sprintf(buf,"------ Race report on %s (%d) ------\n", r->name, p);
		notify(Playernum, buf);
   if(Race->God) {
if(r->God) {
	sprintf(buf, "          *** Diety Status ***\n");
	notify(Playernum, buf);
	}

sprintf(buf,"          (default scope /%s/%s)\n\n",Stars[r->homesystem]->name,
		Stars[r->homesystem]->pnames[r->homeplanetnum] );
		notify(Playernum, buf);
	}
 if (Race->translate[p-1]>50) {
      sprintf(buf,"\nType: %s\n", r->Thing ? "Mesomorphic" : "Normal");
		notify(Playernum, buf);
      sprintf(buf,"         %10srate: %s%%\n", r->Thing ? "Infection " : "Birth",
		Estimate_f(r->birthrate*100.0,Race,p) );
		notify(Playernum, buf);
 } else {
      sprintf(buf,"\nType (mesomorphic or normal): ?\n");
		notify(Playernum, buf);
      sprintf(buf," Approx. expansion rate: %s\n", Estimate_f(r->birthrate,Race,p) );
		notify(Playernum, buf);
 }
 sprintf(buf,"             Technology: %s\n", Estimate_f(r->tech,Race,p) );
		notify(Playernum, buf);
 sprintf(buf,"       Avg Intelligence: %s\n", Estimate_i((int)r->IQ, Race,p) );
		notify(Playernum, buf);
 sprintf(buf,"                   mass: %s\n", Estimate_f(r->mass,Race,p) );
		notify(Playernum, buf);
 sprintf(buf,"             metabolism: %s\n", Estimate_f(r->metabolism,Race,p) );
		notify(Playernum, buf);
 sprintf(buf,"           adventurists: %s%%\n", Estimate_f(r->adventurism*100.0, Race,p) );
 		notify(Playernum, buf);
sprintf(buf,"       fighting ability: %s\n", Estimate_i((int)r->fighters, Race,p) );
		notify(Playernum, buf);
 sprintf(buf,"             # of sexes: %s\n", Estimate_i((int)r->number_sexes, Race,p) );
		notify(Playernum, buf);

  sprintf(buf,"planetary conditions preferred by %s:\n", r->name);
		notify(Playernum, buf);
  sprintf(buf,"    temperature: %s\n", 
	Estimate_i((int)Temp(r->conditions[TEMP]),Race,p) );
		notify(Playernum, buf);
  sprintf(buf," atmosphere concentrations:\n");
		notify(Playernum, buf);
 sprintf(buf,"    Methane %2s%%    Oxygen %2s%%\n",
		Estimate_i((int)r->conditions[METHANE],Race,p), 
		Estimate_i((int)r->conditions[OXYGEN],Race,p) );
		notify(Playernum, buf);
 sprintf(buf,"        CO2 %2s%%  Hydrogen %2s%%\n", 
		Estimate_i((int)r->conditions[CO2],Race,p), 
		Estimate_i((int)r->conditions[HYDROGEN],Race,p) );
		notify(Playernum, buf);
  sprintf(buf,"   Nitrogen %2s%%    Sulfur %2s%%\n",
		Estimate_i((int)r->conditions[NITROGEN],Race,p), 
		Estimate_i((int)r->conditions[SULFUR],Race,p) );
		notify(Playernum, buf);
 sprintf(buf,"     Helium %2s%%     Other %2s%%\n", 
		Estimate_i((int)r->conditions[HELIUM],Race,p), 
		Estimate_i((int)r->conditions[OTHER],Race,p) );

 		notify(Playernum, buf);
 sprintf(buf,"Sector type preference : %s\n", 
	Race->translate[p-1]>80 ? Desnames[r->likesbest] : " ? " );
		notify(Playernum, buf);

  sprintf(buf,"\nTelescope ranges:   ground: %s, space: %s\n", 
	Estimate_f(tele_range(OTYPE_GTELE,r->tech), Race,p), 
	Estimate_f(tele_range(OTYPE_STELE,r->tech), Race,p) );
		notify(Playernum, buf);
  sprintf(buf,"Gun range: %s\n", 
	Estimate_f(gun_range(r, NULL), Race,p) );
		notify(Playernum, buf);

 }

}

static char est_buf[20];

char *Estimate_f(data, r, p)
float data;
racetype *r;
int p;
{

sprintf(est_buf, "?");

 if (r->translate[p-1]>10)
	sprintf(est_buf, "%d", round_perc((int)data, r,p) );

	return est_buf;

}

char *Estimate_i(data, r, p)
int data;
racetype *r;
int p;
{

sprintf(est_buf, "?");

 if (r->translate[p-1]>10)
	sprintf(est_buf, "%2d", round_perc((int)data, r,p) );

	return est_buf;
}


int round_perc(data, r,p)
int data;
racetype *r;
int p;
{
 int k;

 k = 101 - MIN(r->translate[p-1] + r->captured_prisoners[p-1], 100); 

return ((data/k)*k);

}
