/*
 * Galactic Bloodshed, copyright (c) 1989 by Robert P. Chansky, 
 * smq@ucscb.ucsc.edu, mods by people in GB_copyright.h.
 * Restrictions in GB_copyright.h.
 *
 *  ship -- report -- stock -- tactical -- stuff on ship
 */

#define REPORT	0
#define STOCK	1
#define TACTICAL 2
#define SHIP	3
#define OBJECT	4

#define PLANET 1

#include "GB_copyright.h"
#define EXTERN extern
#include "vars.h"
#include "ships.h"
#include "races.h"
#include "buffers.h"
#include <math.h>
#include <ctype.h>
extern char Shipltrs[];

char *prin_aimed_at(), *prin_ship_dest();

static boolean Object,Ship,Stock,Report,Tactical,first;
int rst_racedata;

extern float Kill_factor();

struct reportdata {
	unsigned type : 1;	/* ship or planet */
	shiptype *s;
	planettype *p;
	short n;
	unsigned char star,pnum;
	float x,y;
};

rst(Playernum,APcount, argn,args,Rst)
int Playernum;
int APcount;
int argn;
char args[MAXARGS][COMMANDSIZE];
int Rst;
{
 int shdata,shipno;
 reg int shn,i;
 struct reportdata *rd;
 int n_ships, num;
 boolean Report_types[NUMSTYPES];

 for (i=0; i<NUMSTYPES; i++) Report_types[i]=1;
 Num_ships = 0;
 first = 1;
 switch (Rst) {
	case REPORT:	Report = 1;
			Object = Stock = Ship = Tactical = 0;
			break;
	case STOCK:	Stock = 1;
			Object = Report = Ship = Tactical = 0;
			break;
	case TACTICAL:	Tactical = 1;
			Object = Report = Ship = Stock = 0;
			break;
	case SHIP:	Ship = Report = Stock = 1;
			Tactical = 0;
			Object = 0;
			break;
	case OBJECT:	Object = Report = Stock = Tactical = 1;
			Ship = 0;
			break;
 }

 openshdata(&shdata);
  n_ships = Numships(shdata);
 close_file(shdata);

 rd = (struct reportdata *)malloc(sizeof(struct reportdata) * 
	(n_ships + Sdata.numstars * MAXPLANETS));
	/* (one list entry for each ship, planet in universe) */


 if (argn>=2) {

   if (*args[1] == '#' || isdigit(*args[1])) {
	/* report on a couple ships */
	 int l=1;
      while (l<MAXARGS && *args[l]!='\0') {

      	sscanf(args[l] + (*args[l]=='#'),"%d",&shipno);

      	if ( shipno > n_ships || shipno<1) {
	   sprintf (buf,"rst: no such ship #%d \n",shipno);
		notify(Playernum, buf);
	   return ;
       	}

      	openshdata(&shdata);
      	Getrship(Playernum,shdata,rd, shipno);
      	close_file(shdata);
	num = Num_ships;
	if(rd[Num_ships-1].s->whatorbits != LEVEL_UNIV)
		{
      			star_getrships(Playernum,rd,rd[num-1].s->storbits);
      			ship_report(Playernum,rd,num-1,Report_types);
		}
	else 
   			ship_report(Playernum,rd,num-1,Report_types);

	l++;
      }

      return;

   } else {
	int l;
	l = strlen(args[1]);
	for (i=0; i<NUMSTYPES; i++) Report_types[i]=0;

	while (l--) {
	   i = NUMSTYPES;
	   while (--i && Shipltrs[i]!=args[1][l]) 
		;
	   if (Shipltrs[i]!=args[1][l]) {
		sprintf(buf,"'%c' -- no such ship letter\n",args[1][l]);
			notify(Playernum, buf);
	   } else
		Report_types[i] = 1;
	}
   }

  }

  switch (Dir[Playernum-1].level) {
   case LEVEL_UNIV:
	  openshdata(&shdata);
	  shn = Sdata.ships;
	  while (shn) {
	      Getrship(Playernum,shdata,rd, shn);
	      shn = rd[Num_ships-1].s->nextship;
	  }
	  close_file(shdata);
      for (i=0; i<Sdata.numstars; i++)
        star_getrships(Playernum,rd,i);
      for (i=0; i<Num_ships; i++)
        ship_report(Playernum,rd,i,Report_types);
      break;
   case LEVEL_PLAN:
      plan_getrships(Playernum,rd, Dir[Playernum-1].snum, Dir[Playernum-1].pnum);
      for (i=0; i<Num_ships; i++)
        ship_report(Playernum,rd,i,Report_types);
      break; 
   case LEVEL_STAR:
      star_getrships(Playernum,rd,Dir[Playernum-1].snum);
      for (i=0; i<Num_ships; i++)
        ship_report(Playernum,rd,i,Report_types);
      break; 
   case LEVEL_SHIP:
      openshdata(&shdata);
      Getrship(Playernum,shdata,rd, Dir[Playernum-1].shipno);
      ship_report(Playernum,rd,0,Report_types);		/* first ship report */

	if(rd[0].s->type == STYPE_CARRIER) /* list attached fighter groups */
	{
	  shn = rd[0].s->object.number;
	   Num_ships = 0;	
	  while (shn) {
	      Getrship(Playernum,shdata,rd, shn);
	      shn = rd[Num_ships-1].s->object.number;
	  }

	for (i=0; i<Num_ships; i++)
		ship_report(Playernum,rd,i,Report_types);
	}

      close_file(shdata);
      break;
  }

  Free_shiplist(rd);

}


ship_report(Playernum,rd,indx,rep_on)
int Playernum;
struct reportdata rd[];
int indx;
boolean rep_on[];
{
 shiptype *s;
 planettype *p;
 int shipno,test;
 reg int i,sight;
 placetype where;
 char orb[PLACENAMESIZE];
 char strng[COMMANDSIZE],locstrn[COMMANDSIZE];
 float Dist;

	/* last ship gotten from disk */
  s = rd[indx].s;
  p = rd[indx].p;
  shipno = rd[indx].n;

free(Race);
openracedata(&rst_racedata);
getrace(rst_racedata, &Race, Playernum);
close_file(rst_racedata);

	/* launched canister, non-owned ships don't show up */
    if ( (rd[indx].type==PLANET && p->info[Playernum-1].numsectsowned)
      || (rd[indx].type!=PLANET && s->owner==Playernum &&
	 rep_on[s->type] &&
	!(s->type==OTYPE_CANIST && !s->is_docked) && s->is_alive) ) {

   if (rd[indx].type!=PLANET && Stock) {
    if (first) {
      sprintf(buf,"  #       name     mass armor size   resources destructive   fuel      crew     class\n");
		notify(Playernum, buf);
      if (!Ship && !Object)
	      first=0;
    }


      sprintf(buf,"%3d %c %13.13s%5.1f%6u%5u%5u(%4d)%5u(%4d)%5.1f(%4d)%5u(%4d) %c %s ",
	shipno, Shipltrs[s->type], s->name, s->mass, s->armor, s->size, 
	s->resource, Max_resource(s),
	s->destruct, Max_destruct(s),
	s->fuel, Max_fuel(s),
	s->popn, Max_crew(s), Shipltrs[s->build_type],  s->class);
		notify(Playernum, buf);
      if (!s->active) {
	sprintf(buf," INACTIVE(%d)",s->rad);
		notify(Playernum, buf);
		}
      sprintf(buf,"\n");
		notify(Playernum, buf);

   }



   if (rd[indx].type!=PLANET && Report) {
         if (first) {
		sprintf(buf,"  #                crew dam dest fuel spd            orbits       destination\n");
		notify(Playernum, buf);
		 if (!Ship && !Object)
		      first=0;
	 }

	if(s->navigate.on)
		sprintf(strng,"nav: %d (%d)",s->navigate.bearing,
				s->navigate.turns);

	  sprintf(locstrn,"%2.0f,%-2.0f",s->xpos,s->ypos);

 	  sprintf(buf,"%4d %c %12.12s%4u%4u%5u%5.0f%3u%c%5s%16s%16s",
		shipno, 
		Shipltrs[s->type], 
		s->name,
		s->popn,
		s->damage, 
		s->destruct, 
		s->fuel,
		s->speed, 
		s->is_docked ? ( (s->whatdest==LEVEL_SHIP) ? 'D' : 'L') : ' ',
		(s->is_docked&&s->whatdest==LEVEL_PLAN) ? locstrn : "",
		prin_ship_orbits(s), 
		(s->navigate.on) ? strng : prin_ship_dest(Playernum, s) );
		notify(Playernum, buf);
      if (!s->active) {
	sprintf(buf," INACTIVE(%d)",s->rad);
		notify(Playernum, buf);
		}
         sprintf(buf,"\n");
		notify(Playernum, buf);

   }

   if (Tactical) {

int fev=0,fspeed=0;
float tech;
	sprintf(buf,"\n  #         name        tech guns armor size dest   fuel dam spd evad               orbits\n");
		notify(Playernum, buf);

	if (rd[indx].type==PLANET) {
			tech = Race->tech;
		/* tac report from planet */
		sprintf(buf,"(planet)%15.15s%4.0f %4d           %5u %6u\n",
			Stars[rd[indx].star]->pnames[rd[indx].pnum],
			 tech,PLAN_FIRE_LIM,p->info[Playernum-1].destruct,
			p->info[Playernum-1].fuel);
		notify(Playernum, buf);
	} else {

 	  where.level = s->whatorbits;
 	  where.snum = s->storbits;
 	  where.pnum = s->pnumorbits;
	  tech = s->tech;

	  if((s->whatdest != LEVEL_UNIV || s->navigate.on) && !s->is_docked && s->active) {
		fspeed = s->speed;
		fev = s->protect.evade;
	  }
	  sprintf(orb, "%30.30s", Dispplace(Playernum, &where));
	  sprintf(buf,"%3d %c%19.19s%4.0f%5d%6d%5d%5u%7.1f%3d%%  %d  %3s%21.22", 
		shipno, Shipltrs[s->type], s->name, s->tech,
		Guns(s), s->armor, s->size,
		s->destruct, s->fuel, s->damage, fspeed,(fev ? "yes" : "   "),
		orb );
		notify(Playernum, buf);

	  if (s->is_docked && s->whatorbits==LEVEL_PLAN) {
	    sprintf(buf," (%.0f,%.0f)",s->xpos,s->ypos);
		notify(Playernum, buf);
		}
          if (!s->active) {
		sprintf(buf," INACTIVE(%d)",s->rad);
		notify(Playernum, buf);
			}
	  sprintf(buf,"\n");
		notify(Playernum, buf);

	}

	sight = 0;
	if(rd[indx].type==PLANET) {
		sight = 1;
	} else if(Shipdata[s->type][ABIL_SIGHT]) sight = 1;

		/* tactical display */
	sprintf(buf,"\n  Tactical: #  own typ        name   rng   (50%%) size spd evade hit  dam  loc\n");
		notify(Playernum, buf);

	if(sight)
	for (i=0; i<Num_ships; i++) {
	   if (i!=indx && (Dist = sqrt(Distsq(rd[indx].x, rd[indx].y, 
				rd[i].x, rd[i].y))) < gun_range(Race, NULL))
	      if (rd[i].type==PLANET) {
		/* tac report at planet */
		sprintf(buf," %13s(planet)          %8.0f\n", 
			Stars[rd[i].star]->pnames[rd[i].pnum], Dist);
		notify(Playernum, buf);

	      } else {
			/* tac report at ship */
		if (rd[i].s->owner!=Playernum && rd[i].s->is_alive
			&& rd[i].s->type != OTYPE_CANIST)
			 {
		int tev=0, tspeed=0, body=0,prob=0;
		int factor=0;		
		if((rd[i].s->whatdest != LEVEL_UNIV || rd[i].s->navigate.on) && !rd[i].s->is_docked && rd[i].s->active)
					{
					tspeed = rd[i].s->speed;
					tev = rd[i].s->protect.evade;
					}
					
		body = Size(rd[i].s);

			 prob = hit_odds(Dist,&factor,tech,fev,tev,fspeed,tspeed,body);
		   sprintf(buf,"%13d %4d %c%15.15s %4.0f  %4d   %5d%d  %3s  %3d%% %3u%%",
			rd[i].n, rd[i].s->owner, Shipltrs[rd[i].s->type], 
			rd[i].s->name, Dist,factor,body,tspeed,(tev ? "yes" : "   "), prob,rd[i].s->damage);
		notify(Playernum, buf);
	  if (rd[i].s->is_docked && rd[i].s->whatorbits==LEVEL_PLAN) {
	    sprintf(buf," (%.0f,%.0f)",rd[i].s->xpos,rd[i].s->ypos);
		notify(Playernum, buf);
	  } else {
	    sprintf(buf,"     ");
		notify(Playernum, buf);
		}

	sprintf(buf, "\n");
		notify(Playernum, buf);
		}
	      }

	}
   }


  }

}



plan_getrships(Playernum,rd,snum,pnum)
int Playernum;
struct reportdata rd[];
int snum, pnum;
{
 reg int i,shn;
 planettype *p;
 int shdata,pdata;

 openpdata(&pdata);
   getplanet(pdata, &rd[Num_ships].p, Stars[snum]->planetpos[pnum]);
 close_file(pdata);
 p = rd[Num_ships].p;
	/* add this planet into the ship list */
 rd[Num_ships].star = snum;
 rd[Num_ships].pnum = pnum;
 rd[Num_ships].type = PLANET;
 rd[Num_ships].n = 0;
 rd[Num_ships].x = Stars[snum]->xpos + p->xpos;
 rd[Num_ships].y = Stars[snum]->ypos + p->ypos;
    Num_ships++;

 if (p->info[Playernum-1].explored) {

   openshdata(&shdata);
   shn = p->ships;
   while (shn) {

	Getrship(Playernum,shdata, rd, shn);
		/* add offsets for docked ships */
	if (rd[Num_ships-1].s->is_docked && 
			rd[Num_ships-1].s->whatdest==LEVEL_PLAN) {
		rd[Num_ships-1].x += Stars[snum]->xpos + p->xpos;
		rd[Num_ships-1].y += Stars[snum]->ypos + p->ypos;
	}
	shn = rd[Num_ships-1].s->nextship;
   }
   close_file(shdata);
 }
 
}



star_getrships(Playernum,rd,snum)
int Playernum;
struct reportdata rd[];
int snum;
{
 reg int shn;
 int i,shdata;


 if (isset(Stars[snum]->explored, Playernum)) {
   openshdata(&shdata);
   shn = Stars[snum]->ships;
   while (shn) {
	Getrship(Playernum,shdata, rd, shn);
	shn = rd[Num_ships-1].s->nextship;
   }
   close_file(shdata);
   for (i=0; i<Stars[snum]->numplanets; i++)
     plan_getrships(Playernum,rd, snum, i);
 }
}


/* get a ship from the disk and add it to the ship list we're maintaining. */
Getrship(Playernum,shdata,rd, shipno)
int Playernum;
int shdata,shipno;
struct reportdata rd[];
{
int noerr;

 
   if (getship(shdata,&rd[Num_ships].s,shipno)) {
	   rd[Num_ships].type = 0;
	   rd[Num_ships].n = shipno;
	   rd[Num_ships].x = rd[Num_ships].s->xpos;
	   rd[Num_ships].y = rd[Num_ships].s->ypos;
 	   Num_ships++;
   } else {
	sprintf(buf,"Getrship: error on ship get (%d).\n",shipno);
		notify(Playernum, buf);
   }
}



Free_shiplist(rd)
struct reportdata rd[];
{
 reg int i;

 for (i=0; i<Num_ships; i++)
	if (rd[i].type==PLANET)
		free(rd[i].p);
	else
		free(rd[i].s);

 free(rd);
}

/* 
 * return what the ship is aimed at, if it's a mirror 
 */


